/* book pages 53-54 */
#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#define LENGTH 60000

int main(int argc,char * argv[]){
    int counter, rank, size, flag;
    double sendBuffer [LENGTH];
    double recvBuffer [LENGTH];
    double startTime, endTime;
    MPI_Request sendReq, recvReq;
    MPI_Status status;

    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD,&rank);
    MPI_Comm_size(MPI_COMM_WORLD,&size);

    if (size!=2) {
        if (rank==0)
            printf ("Invalid Process Number. Only two processes
                     are required\n");
        MPI_Abort (MPI_COMM_WORLD, -1); }
    srand ((unsigned)time(NULL)+rank);
    for (counter=0;counter<LENGTH;counter++) {
         sendBuffer[counter]=(double)rand()/RAND_MAX;
         recvBuffer[counter]=(double)0; }

    startTime = MPI_Wtime();
    if (rank==0) {
        printf ("Send Operation started at time %.9f\n",
                startTime);
        MPI_Isend (sendBuffer, LENGTH, MPI_DOUBLE, 1, 0,
                   MPI_COMM_WORLD, &sendReq);
    do {
        MPI_Test (&sendReq, &flag, &status);
        printf ("Send not completed at time %.9f\n",
                MPI_Wtime());
       }  while (flag==(int)false);
    if (flag==(int)true)
        printf ("Send Operation completed at time %.9f\n",
                 MPI_Wtime()); }
    if (rank==1)
        MPI_Irecv (recvBuffer, LENGTH, MPI_DOUBLE, 0, 0,
                   MPI_COMM_WORLD, &recvReq);
    endTime = MPI_Wtime();

    MPI_Finalize();
    return (0); }
