/* book pages 237-238 */
#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>

#define DIM 4

int main (int argc, char ** argv) {
    int i, oldRank, oldSize, a = 10;
    double buf; double b [DIM] = {0.125, 0.450, 1.375, 2.225};
    int ranks1[DIM], ranks2[DIM];
    MPI_Group commGroup, newGroup1, newGroup2;
    int newRank1, newRank2;
    MPI_Comm newComm1, newComm2;

    MPI_Init (&argc, &argv);
    MPI_Comm_rank (MPI_COMM_WORLD, &oldRank);
    MPI_Comm_size (MPI_COMM_WORLD, &oldSize);

    if (oldSize!=2*DIM) {
        if (oldRank==0)
            printf ("Invalid process number. Aborting...\n");
        MPI_Finalize ();
        return (-1); }

    for (i=0;i<DIM;i++) {
         ranks1[i] = 2*i;
         ranks2[i] = 2*i+1; }

    MPI_Comm_group (MPI_COMM_WORLD, &commGroup);

    MPI_Group_incl (commGroup, DIM, ranks1, &newGroup1);
    MPI_Group_incl (commGroup, DIM, ranks2, &newGroup2);

    MPI_Comm_create (MPI_COMM_WORLD, newGroup1, &newComm1);
    MPI_Comm_create (MPI_COMM_WORLD, newGroup2, &newComm2);

    if (newComm1) MPI_Comm_rank (newComm1, &newRank1);
    if (newComm2) MPI_Comm_rank (newComm2, &newRank2);
    if (newComm1) {
        MPI_Bcast (&a, 1, MPI_INT, 0, newComm1);
        printf ("Process %d of group %d received a value of %d
                 from process 0\n", newRank1, newGroup1, a);}
    if (newComm2) {
        MPI_Scatter (&b, 1, MPI_DOUBLE, &buf, 1,
                     MPI_DOUBLE, 2, newComm2);
          printf ("Process %d of group %d received a value
                   of %f from process 2\n",
                   newRank2, newGroup2, buf); }

    MPI_Group_free (&newGroup1);
    if (newComm1) MPI_Comm_free (&newComm1);

    MPI_Group_free (&newGroup2);
    if (newComm2) MPI_Comm_free (&newComm2);

    MPI_Finalize ();
    return (0); }
