/* book pages 532-533*/

#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>

#define LENGTH 8
#define MESSAGES 10
#define CALCULATE   10
#define DISCONNECT  20


int main (int argc, char **argv) {
    MPI_Comm server;
    double buffer [LENGTH];
    int msgs=0, done=0, counter, retVal;
    char portName [MPI_MAX_PORT_NAME];

    printf ("Starting client...\n");
    MPI_Init(&argc, &argv);
    strcpy(portName, argv[1] );
    printf("Connecting to port %s\n", portName);

    retVal=MPI_Comm_connect(portName, MPI_INFO_NULL,
               0, MPI_COMM_WORLD,  &server );
    if (retVal!=MPI_SUCCESS) {
        printf ("Could not connect to server %s\n",
                 port_name);
        MPI_Finalize();
        return (-1); }

    while (!done) {
        if (msgs==MESSAGES) done=1;
        for (counter=0;counter<LENGTH;counter++)
             buffer[counter]=(double)rand()/RAND_MAX;
        MPI_Send ( buffer,LENGTH, MPI_DOUBLE, 0,
                   CALCULATE, server );
        printf ("Msg [%03d] Data: ", msgs);
        for (counter=0;counter<LENGTH;counter++)
             printf ("%.3f ", buffer[counter]);
        printf ("\n");
        msgs++; }

    MPI_Send(buffer, 0, MPI_DOUBLE, 0, DISCONNECT, server);
    MPI_Comm_disconnect( &server );
    MPI_Finalize();
    return 0; }


