/* book pages 533-534*/

#include <mpi.h>
#include <stdio.h>

#define CALCULATE  10
#define DISCONNECT 20

#define LENGTH 10


int main (int argc, char **argv) {
    MPI_Comm client;
    MPI_Status status;
    char port_name[MPI_MAX_PORT_NAME];
    double buffer [LENGTH];
    double mean, max, min;
    int size, again, counter;

    MPI_Init (&argc, &argv);
    MPI_Comm_size (MPI_COMM_WORLD, &size);
    if (size != 1) {
        printf ("Server too big!\n");
        MPI_Finalize();
        return (-1); }

    MPI_Open_port (MPI_INFO_NULL, port_name);
    printf ("server available at %s\n",port_name);

    while (1) {
        MPI_Comm_accept( port_name, MPI_INFO_NULL, 0,
                         MPI_COMM_WORLD, &client );
        printf ("Accepting client requests....\n");
        again = 1;
        while (again) {
            MPI_Recv(buffer, LENGTH, MPI_DOUBLE, MPI_ANY_SOURCE,
                     MPI_ANY_TAG, client, &status );
            switch (status.MPI_TAG) {
                case TERMINATE:
                     printf ("Shutting down server...\n");
                     MPI_Comm_free( &client );
                     MPI_Close_port(port_name);
                     MPI_Finalize();
                     return 0;
                case DISCONNECT:
                     printf ("Client disconnect request
                              detected\n");
                     again = 0;
                     break;
                case CALCULATE:
                     mean=0.0;
                     for (counter=0;counter<LENGTH;counter++)
                          mean+=buffer[counter];
                     mean/=LENGTH;
                     min = max = buffer[0];
                     for (counter=0;counter<LENGTH;counter++) {
                          if (buffer[counter]<min)
                              min=buffer[counter];
                          if (buffer[counter]>max)
                              max=buffer[counter];}
                     printf ("Mean Value is %.3f Min Value is
                              %.3f Max Value is %.3f\n",
                              mean, min, max);
                     break;
                default: MPI_Abort( MPI_COMM_WORLD, 1 ); }}}}
